<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ZConvertAmmount.RfcException StructType
 * @subpackage Structs
 */
class ZConvertAmmount_RfcException extends AbstractStructBase
{
    /**
     * The Name
     * @var string
     */
    public $Name;
    /**
     * The Text
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Text;
    /**
     * The Message
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RfcException_Message
     */
    public $Message;
    /**
     * Constructor method for ZConvertAmmount.RfcException
     * @uses ZConvertAmmount_RfcException::setName()
     * @uses ZConvertAmmount_RfcException::setText()
     * @uses ZConvertAmmount_RfcException::setMessage()
     * @param string $name
     * @param string $text
     * @param \StructType\RfcException_Message $message
     */
    public function __construct($name = null, $text = null, \StructType\RfcException_Message $message = null)
    {
        $this
            ->setName($name)
            ->setText($text)
            ->setMessage($message);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @uses \EnumType\ZConvertAmmount_RfcExceptions::valueIsValid()
     * @uses \EnumType\ZConvertAmmount_RfcExceptions::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $name
     * @return \StructType\ZConvertAmmount_RfcException
     */
    public function setName($name = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\ZConvertAmmount_RfcExceptions::valueIsValid($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\ZConvertAmmount_RfcExceptions', is_array($name) ? implode(', ', $name) : var_export($name, true), implode(', ', \EnumType\ZConvertAmmount_RfcExceptions::getValidValues())), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Text value
     * @return string|null
     */
    public function getText()
    {
        return $this->Text;
    }
    /**
     * Set Text value
     * @param string $text
     * @return \StructType\ZConvertAmmount_RfcException
     */
    public function setText($text = null)
    {
        // validation for constraint: string
        if (!is_null($text) && !is_string($text)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($text, true), gettype($text)), __LINE__);
        }
        $this->Text = $text;
        return $this;
    }
    /**
     * Get Message value
     * @return \StructType\RfcException_Message|null
     */
    public function getMessage()
    {
        return $this->Message;
    }
    /**
     * Set Message value
     * @param \StructType\RfcException_Message $message
     * @return \StructType\ZConvertAmmount_RfcException
     */
    public function setMessage(\StructType\RfcException_Message $message = null)
    {
        $this->Message = $message;
        return $this;
    }
}
